#ifndef MCSOPTIONS_H_
#define MCSOPTIONS_H_

#include <vector>
#include <string>

class ExpaRNAOptions
{
public:
	ExpaRNAOptions()
		{
			minPatternSize 				= 2;
			maxPatternNumber 			= 0;
			calcLCSEPM					= false;
			alignColor					= false;
  			verboseOut					= false;
  			alignOut					= false;
  			locarnaOut					= false;
  			epmOut						= false;
  			outfile						= "LCS_EPM_align.aln";
  			locarna_file				= "LCS_EPM_LocARNA.fa";
  			epm_file					= "LCS_EPM.epm";
  			clusterSaveCounter 			= 1;
		};

	ExpaRNAOptions(const ExpaRNAOptions& myOptions): cmdLineValues(myOptions.cmdLineValues),
										     minPatternSize(myOptions.minPatternSize),
										     maxPatternNumber(myOptions.maxPatternNumber),
										     clusterSaveCounter(myOptions.clusterSaveCounter),
										     calcLCSEPM(myOptions.calcLCSEPM),
										     alignColor(myOptions.alignColor),
										     verboseOut(myOptions.verboseOut),
										     alignOut(myOptions.alignOut),
										     locarnaOut(myOptions.locarnaOut),
										     epmOut(myOptions.epmOut),
										     outfile(myOptions.outfile),
										     locarna_file(myOptions.locarna_file),
										     epm_file(myOptions.epm_file) {};

	virtual ~ExpaRNAOptions();

		std::vector<std::string>	 cmdLineValues;

		std::string					mol1Id;
		std::string 				mol2Id;

		int					minPatternSize;
		int					maxPatternNumber;
  		int    				clusterSaveCounter;
  		bool				calcLCSEPM;
  		bool				alignColor;
  		bool				verboseOut;
  		bool				alignOut;
  		bool				locarnaOut;
  		bool				epmOut;
  		std::string			outfile;
  		std::string			locarna_file;
  		std::string			epm_file;
};

#endif /*MCSOPTIONS_H_*/
